unit uMultiPromedioMovil;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, xmatdefs, uDatosHistoricos;

type

  { TForm1 }

  TForm1 = class(TForm)
    btEjecutar: TButton;
    eFrom: TLabeledEdit;
    OpenDialog1: TOpenDialog;
    procedure btEjecutarClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btEjecutarClick(Sender: TObject);
var
  s: TDatosHistoricos;
  archi: string;
  k, j: integer;
  pms: TMatOfNReal;
  n10m: integer;
  a: NReal;
  sal: textfile;

begin
  if not OpenDialog1.Execute then exit;
  archi:= OpenDialog1.FileName;
  s:= TDatosHistoricos.CreateFromArchi( archi );

  pms:= create_MatOfNreal( s.nPuntosSeries, 48 );
  for k:= 1 to 48 do
  begin
    a:= 0;
    n10m:= k*6;
    for j:= 0 to n10m-1 do
    begin
     a:= a+ (s.series[3][j]-s.series[2][j])/ n10m;
     pms[j][k-1]:= a;
    end;
    for j:= n10m to s.nPuntosSeries -1  do
    begin
     a:= a +(-(s.series[3][j-n10m]-s.series[2][j-n10m] ) + s.series[3][j]-s.series[2][j]) / n10m;
     pms[j][k-1]:= a;
    end;
  end;

  assignfile( sal, 'c:\basura\pms.xlt' );
  rewrite( sal );

  write( sal, '-');
  for k:= 0 to 47 do
    write( sal, #9, k+1 );
  writeln( sal );

  for j:= 0 to s.nPuntosSeries - 1 do
  begin
   if j mod 6 = 0 then
   begin
     write( sal, round(j / 6));
     for k:= 0 to 47 do
       write( sal, #9, pms[j][k] );
     writeln( sal );
   end;
  end;
  closefile( sal );
end;

end.

